"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("react"),t=require("styled-components");function n(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function o(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var o=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,o.get?o:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,Object.freeze(t)}var a,l=o(e),r=n(e),i=n(t);function s(e,t){return e[t]}function d(e,t){return t.split(".").reduce(((e,t)=>{const n=t.match(/[^\]\\[.]+/g);if(n&&n.length>1)for(let t=0;t<n.length;t++)return e[n[t]][n[t+1]];return e[t]}),e)}function c(e=[],t,n=0){return[...e.slice(0,n),t,...e.slice(n)]}function g(e=[],t,n="id"){const o=e.slice(),a=s(t,n);return a?o.splice(o.findIndex((e=>s(e,n)===a)),1):o.splice(o.findIndex((e=>e===t)),1),o}function u(e){return e.map(((e,t)=>{const n=Object.assign(Object.assign({},e),{sortable:e.sortable||!!e.sortFunction||void 0});return e.id||(n.id=t+1),n}))}function p(e,t){return Math.ceil(e/t)}function f(e,t){return Math.min(e,t)}!function(e){e.ASC="asc",e.DESC="desc"}(a||(a={}));const m=()=>null;function b(e,t=[],n=[]){let o={},a=[...n];return t.length&&t.forEach((t=>{if(!t.when||"function"!=typeof t.when)throw new Error('"when" must be defined in the conditional style object and must be function');t.when(e)&&(o=t.style||{},t.classNames&&(a=[...a,...t.classNames]),"function"==typeof t.style&&(o=t.style(e)||{}))})),{style:o,classNames:a.join(" ")}}function h(e,t=[],n="id"){const o=s(e,n);return o?t.some((e=>s(e,n)===o)):t.some((t=>t===e))}function w(e,t){return t?e.findIndex((e=>x(e.id,t))):-1}function x(e,t){return e==t}function C(e,t){const n=!e.toggleOnSelectedRowsChange;switch(t.type){case"SELECT_ALL_ROWS":{const{keyField:n,rows:o,rowCount:a,mergeSelections:l}=t,r=!e.allSelected,i=!e.toggleOnSelectedRowsChange;if(l){const t=r?[...e.selectedRows,...o.filter((t=>!h(t,e.selectedRows,n)))]:e.selectedRows.filter((e=>!h(e,o,n)));return Object.assign(Object.assign({},e),{allSelected:r,selectedCount:t.length,selectedRows:t,toggleOnSelectedRowsChange:i})}return Object.assign(Object.assign({},e),{allSelected:r,selectedCount:r?a:0,selectedRows:r?o:[],toggleOnSelectedRowsChange:i})}case"SELECT_SINGLE_ROW":{const{keyField:o,row:a,isSelected:l,rowCount:r,singleSelect:i}=t;return i?l?Object.assign(Object.assign({},e),{selectedCount:0,allSelected:!1,selectedRows:[],toggleOnSelectedRowsChange:n}):Object.assign(Object.assign({},e),{selectedCount:1,allSelected:!1,selectedRows:[a],toggleOnSelectedRowsChange:n}):l?Object.assign(Object.assign({},e),{selectedCount:e.selectedRows.length>0?e.selectedRows.length-1:0,allSelected:!1,selectedRows:g(e.selectedRows,a,o),toggleOnSelectedRowsChange:n}):Object.assign(Object.assign({},e),{selectedCount:e.selectedRows.length+1,allSelected:e.selectedRows.length+1===r,selectedRows:c(e.selectedRows,a),toggleOnSelectedRowsChange:n})}case"SELECT_MULTIPLE_ROWS":{const{keyField:o,selectedRows:a,totalRows:l,mergeSelections:r}=t;if(r){const t=[...e.selectedRows,...a.filter((t=>!h(t,e.selectedRows,o)))];return Object.assign(Object.assign({},e),{selectedCount:t.length,allSelected:!1,selectedRows:t,toggleOnSelectedRowsChange:n})}return Object.assign(Object.assign({},e),{selectedCount:a.length,allSelected:a.length===l,selectedRows:a,toggleOnSelectedRowsChange:n})}case"CLEAR_SELECTED_ROWS":{const{selectedRowsFlag:n}=t;return Object.assign(Object.assign({},e),{allSelected:!1,selectedCount:0,selectedRows:[],selectedRowsFlag:n})}case"SORT_CHANGE":{const{sortDirection:o,selectedColumn:a,clearSelectedOnSort:l}=t;return Object.assign(Object.assign(Object.assign({},e),{selectedColumn:a,sortDirection:o,currentPage:1}),l&&{allSelected:!1,selectedCount:0,selectedRows:[],toggleOnSelectedRowsChange:n})}case"CHANGE_PAGE":{const{page:o,paginationServer:a,visibleOnly:l,persistSelectedOnPageChange:r}=t,i=a&&r,s=a&&!r||l;return Object.assign(Object.assign(Object.assign(Object.assign({},e),{currentPage:o}),i&&{allSelected:!1}),s&&{allSelected:!1,selectedCount:0,selectedRows:[],toggleOnSelectedRowsChange:n})}case"CHANGE_ROWS_PER_PAGE":{const{rowsPerPage:n,page:o}=t;return Object.assign(Object.assign({},e),{currentPage:o,rowsPerPage:n})}}}const v=t.css`
	pointer-events: none;
	opacity: 0.4;
`,y=i.default.div`
	position: relative;
	box-sizing: border-box;
	display: flex;
	flex-direction: column;
	width: 100%;
	height: 100%;
	max-width: 100%;
	${({disabled:e})=>e&&v};
	${({theme:e})=>e.table.style};
`,R=t.css`
	position: sticky;
	position: -webkit-sticky; /* Safari */
	top: 0;
	z-index: 2;
`,S=i.default.div`
	display: flex;
	width: 100%;
	${({fixedHeader:e})=>e&&R};
	${({theme:e})=>e.head.style};
`,E=i.default.div`
	display: flex;
	align-items: stretch;
	width: 100%;
	${({theme:e})=>e.headRow.style};
	${({dense:e,theme:t})=>e&&t.headRow.denseStyle};
`,O=(e,...n)=>t.css`
		@media screen and (max-width: ${599}px) {
			${t.css(e,...n)}
		}
	`,k=(e,...n)=>t.css`
		@media screen and (max-width: ${959}px) {
			${t.css(e,...n)}
		}
	`,P=(e,...n)=>t.css`
		@media screen and (max-width: ${1280}px) {
			${t.css(e,...n)}
		}
	`,D=e=>(n,...o)=>t.css`
				@media screen and (max-width: ${e}px) {
					${t.css(n,...o)}
				}
			`,$=(e,...n)=>t.css`
    @media screen and (min-width: ${599}px) {
      ${t.css(e,...n)}
    }
  `,H=(e,...n)=>t.css`
    @media screen and (min-width: ${959}px) {
      ${t.css(e,...n)}
    }
  `,j=(e,...n)=>t.css`
    @media screen and (min-width: ${1280}px) {
      ${t.css(e,...n)}
    }
  `,F=e=>(n,...o)=>t.css`
        @media screen and (min-width: ${e}px) {
          ${t.css(n,...o)}
        }
      `,I=i.default.div`
	position: relative;
	display: flex;
	align-items: center;
	box-sizing: border-box;
	line-height: normal;
	${({theme:e,headCell:t})=>e[t?"headCells":"cells"].style};
	${({noPadding:e})=>e&&"padding: 0"};
`,T=e=>`\n    position: sticky;\n    background-color: inherit;\n    left: ${e};\n    z-index: 1;\n  `,L=i.default(I).attrs((e=>({style:{maxWidth:e.width?e.width:e.maxWidth?e.maxWidth:"100%",minWidth:e.width?e.width:e.minWidth?e.minWidth:"100px"}})))`
	flex-grow: ${({button:e,grow:t})=>0===t||e?0:t||1};
	flex-shrink: 0;
	flex-basis: 0;
	${({right:e})=>e&&"justify-content: flex-end"};
	${({button:e,center:t})=>(t||e)&&"justify-content: center"};
	${({compact:e,button:t})=>(e||t)&&"padding: 0"};

	/* handle hiding cells */
	${({hide:e})=>e&&"sm"===e&&O`
    display: none;
  `};
	${({hide:e})=>e&&"md"===e&&k`
    display: none;
  `};
	${({hide:e})=>e&&"lg"===e&&P`
    display: none;
  `};
	${({hide:e})=>e&&Number.isInteger(e)&&D(e)`
    display: none;
  `};
  /* handle freezing cells */
	${({freeze:e,leftOffset:t})=>e&&"sm"===e&&t&&$`
    ${T(t)}
  `};
	${({freeze:e,leftOffset:t})=>e&&"md"===e&&t&&H`
    ${T(t)}
  `};
	${({freeze:e,leftOffset:t})=>e&&"lg"===e&&t&&j`
    ${T(t)}
  `};
	${({freeze:e,leftOffset:t})=>e&&t&&Number.isInteger(e)&&F(e)`
		${T(t)}
	`};
	${({freeze:e,leftOffset:n})=>!0===e&&n&&t.css`
		${T(n)}
  `};
`,M=t.css`
	div:first-child {
		white-space: ${({wrapCell:e})=>e?"normal":"nowrap"};
		overflow: ${({allowOverflow:e})=>e?"visible":"hidden"};
		text-overflow: ellipsis;
	}
`,z=i.default(L).attrs((e=>({style:e.style})))`
	${({renderAsCell:e})=>!e&&M};
	${({theme:e,isDragging:t})=>t&&e.cells.draggingStyle};
	${({cellStyle:e})=>e};
  padding-left: ${({paddingLeft:e})=>e||"1.5rem"} !important;
  padding-right: ${({paddingRight:e})=>e||"1.5rem"} !important;
`;var A=l.memo((function({id:e,column:t,row:n,rowIndex:o,dataTag:a,isDragging:r,onDragStart:i,onDragOver:s,onDragEnd:c,onDragEnter:g,onDragLeave:u}){const{style:p,classNames:f}=b(n,t.conditionalCellStyles,["rdt_TableCell"]);return l.createElement(z,{id:e,"data-column-id":t.id,role:"cell",className:f,"data-tag":a,cellStyle:t.style,renderAsCell:!!t.cell,allowOverflow:t.allowOverflow,button:t.button,center:t.center,compact:t.compact,grow:t.grow,hide:t.hide,freeze:t.freeze,leftOffset:t.leftOffset,maxWidth:t.maxWidth,minWidth:t.minWidth,right:t.right,width:t.width,wrapCell:t.wrap,style:p,isDragging:r,onDragStart:i,onDragOver:s,onDragEnd:c,onDragEnter:g,onDragLeave:u,paddingLeft:t.paddingLeft,paddingRight:t.paddingRight},!t.cell&&l.createElement("div",{"data-tag":a},function(e,t,n,o){if(!t)return null;if("string"!=typeof t&&"function"!=typeof t)throw new Error("selector must be a . delimited string eg (my.property) or function (e.g. row => row.field");return n&&"function"==typeof n?n(e,o):t&&"function"==typeof t?t(e,o):d(e,t)}(n,t.selector,t.format,o)),t.cell&&t.cell(n,o,t,e))}));const _="input";var N=l.memo((function({name:e,component:t=_,componentOptions:n={style:{}},indeterminate:o=!1,checked:a=!1,disabled:r=!1,onClick:i=m}){const s=t,d=s!==_?n.style:(e=>Object.assign(Object.assign({fontSize:"18px"},!e&&{cursor:"pointer"}),{padding:0,marginTop:"1px",verticalAlign:"middle",position:"relative"}))(r),c=l.useMemo((()=>function(e,...t){let n;return Object.keys(e).map((t=>e[t])).forEach(((o,a)=>{const l=e;"function"==typeof o&&(n=Object.assign(Object.assign({},l),{[Object.keys(e)[a]]:o(...t)}))})),n||e}(n,o)),[n,o]);return l.createElement(s,Object.assign({type:"checkbox",ref:e=>{e&&(e.indeterminate=o)},style:d,onClick:r?m:i,name:e,"aria-label":e,checked:a,disabled:r},c,{onChange:m}))}));const W=i.default(I)`
	flex: 0 0 48px;
	min-width: 48px;
	justify-content: center;
	align-items: center;
	user-select: none;
	white-space: nowrap;
`;function B({name:e,keyField:t,row:n,rowCount:o,selected:a,selectableRowsComponent:r,selectableRowsComponentProps:i,selectableRowsSingle:s,selectableRowDisabled:d,onSelectedRow:c}){const g=!(!d||!d(n));return l.createElement(W,{onClick:e=>e.stopPropagation(),className:"rdt_TableCell",noPadding:!0},l.createElement(N,{name:e,component:r,componentOptions:i,checked:a,"aria-checked":a,onClick:()=>{c({type:"SELECT_SINGLE_ROW",row:n,isSelected:a,keyField:t,rowCount:o,singleSelect:s})},disabled:g}))}const G=i.default.button`
	display: inline-flex;
	align-items: center;
	user-select: none;
	white-space: nowrap;
	border: none;
	background-color: transparent;
	${({theme:e})=>e.expanderButton.style};
`;function V({disabled:e=!1,expanded:t=!1,expandableIcon:n,id:o,row:a,onToggled:r}){const i=t?n.expanded:n.collapsed;return l.createElement(G,{"aria-disabled":e,onClick:()=>r&&r(a),"data-testid":`expander-button-${o}`,disabled:e,"aria-label":t?"Collapse Row":"Expand Row",role:"button",type:"button"},i)}const U=i.default(I)`
	white-space: nowrap;
	font-weight: 400;
	min-width: 48px;
	${({theme:e})=>e.expanderCell.style};
`;function q({row:e,expanded:t=!1,expandableIcon:n,id:o,onToggled:a,disabled:r=!1}){return l.createElement(U,{onClick:e=>e.stopPropagation(),noPadding:!0},l.createElement(V,{id:o,row:e,expanded:t,expandableIcon:n,disabled:r,onToggled:a}))}const Y=i.default.div`
	width: 100%;
	box-sizing: border-box;
	${({theme:e})=>e.expanderRow.style};
	${({extendedRowStyle:e})=>e};
`;var K=l.memo((function({data:e,ExpanderComponent:t,expanderComponentProps:n,extendedRowStyle:o,extendedClassNames:a}){const r=["rdt_ExpanderRow",...a.split(" ").filter((e=>"rdt_TableRow"!==e))].join(" ");return l.createElement(Y,{className:r,extendedRowStyle:o},l.createElement(t,Object.assign({data:e},n)))}));const X="allowRowEvents";var J,Q,Z;exports.Direction=void 0,(J=exports.Direction||(exports.Direction={})).LTR="ltr",J.RTL="rtl",J.AUTO="auto",exports.Alignment=void 0,(Q=exports.Alignment||(exports.Alignment={})).LEFT="left",Q.RIGHT="right",Q.CENTER="center",exports.Media=void 0,(Z=exports.Media||(exports.Media={})).SM="sm",Z.MD="md",Z.LG="lg";const ee=t.css`
	&:hover {
		${({highlightOnHover:e,theme:t})=>e&&t.rows.highlightOnHoverStyle};
	}
`,te=t.css`
	&:hover {
		cursor: pointer;
	}
`,ne=i.default.div.attrs((e=>({style:e.style})))`
	display: flex;
	align-items: stretch;
	align-content: stretch;
	width: 100%;
	box-sizing: border-box;
	${({theme:e})=>e.rows.style};
	${({dense:e,theme:t})=>e&&t.rows.denseStyle};
	${({striped:e,theme:t})=>e&&t.rows.stripedStyle};
	${({highlightOnHover:e})=>e&&ee};
	${({pointerOnHover:e})=>e&&te};
	${({selected:e,theme:t})=>e&&t.rows.selectedHighlightStyle};
`;function oe({columns:e=[],conditionalRowStyles:t=[],defaultExpanded:n=!1,defaultExpanderDisabled:o=!1,dense:a=!1,expandableIcon:r,expandableRows:i=!1,expandableRowsComponent:d,expandableRowsComponentProps:c,expandableRowsHideExpander:g,expandOnRowClicked:u=!1,expandOnRowDoubleClicked:p=!1,highlightOnHover:f=!1,id:h,expandableInheritConditionalStyles:w,keyField:C,onRowClicked:v=m,onRowDoubleClicked:y=m,onRowMouseEnter:R=m,onRowMouseLeave:S=m,onRowExpandToggled:E=m,onSelectedRow:O=m,pointerOnHover:k=!1,row:P,rowCount:D,rowIndex:$,selectableRowDisabled:H=null,selectableRows:j=!1,selectableRowsComponent:F,selectableRowsComponentProps:I,selectableRowsHighlight:T=!1,selectableRowsSingle:L=!1,selected:M,striped:z=!1,draggingColumnId:_,onDragStart:N,onDragOver:W,onDragEnd:G,onDragEnter:V,onDragLeave:U}){const[Y,J]=l.useState(n);l.useEffect((()=>{J(n)}),[n]);const Q=l.useCallback((()=>{J(!Y),E(!Y,P)}),[Y,E,P]),Z=k||i&&(u||p),ee=l.useCallback((e=>{e.target&&e.target.getAttribute("data-tag")===X&&(v(P,e),!o&&i&&u&&Q())}),[o,u,i,Q,v,P]),te=l.useCallback((e=>{e.target&&e.target.getAttribute("data-tag")===X&&(y(P,e),!o&&i&&p&&Q())}),[o,p,i,Q,y,P]),oe=l.useCallback((e=>{R(P,e)}),[R,P]),ae=l.useCallback((e=>{S(P,e)}),[S,P]),le=s(P,C),{style:re,classNames:ie}=b(P,t,["rdt_TableRow"]),se=T&&M,de=w?re:{},ce=z&&$%2==0;return l.createElement(l.Fragment,null,l.createElement(ne,{id:`row-${h}`,role:"row",striped:ce,highlightOnHover:f,pointerOnHover:!o&&Z,dense:a,onClick:ee,onDoubleClick:te,onMouseEnter:oe,onMouseLeave:ae,className:ie,selected:se,style:re},j&&l.createElement(B,{name:`select-row-${le}`,keyField:C,row:P,rowCount:D,selected:M,selectableRowsComponent:F,selectableRowsComponentProps:I,selectableRowDisabled:H,selectableRowsSingle:L,onSelectedRow:O}),i&&!g&&l.createElement(q,{id:le,expandableIcon:r,expanded:Y,row:P,onToggled:Q,disabled:o}),e.map((e=>e.omit?null:l.createElement(A,{id:`cell-${e.id}-${le}`,key:`cell-${e.id}-${le}`,dataTag:e.ignoreRowClick||e.button?null:X,column:e,row:P,rowIndex:$,isDragging:x(_,e.id),onDragStart:N,onDragOver:W,onDragEnd:G,onDragEnter:V,onDragLeave:U})))),i&&Y&&l.createElement(K,{key:`expander-${le}`,data:P,extendedRowStyle:de,extendedClassNames:ie,ExpanderComponent:d,expanderComponentProps:c}))}const ae=i.default.span`
	padding: 2px;
	color: inherit;
	flex-grow: 0;
	flex-shrink: 0;
	${({sortActive:e})=>e?"opacity: 1":"opacity: 0"};
	${({sortDirection:e})=>"desc"===e&&"transform: rotate(180deg)"};
`,le=({sortActive:e,sortDirection:t})=>r.default.createElement(ae,{sortActive:e,sortDirection:t},"▲"),re=i.default(L)`
	${({button:e})=>e&&"text-align: center"};
	${({theme:e,isDragging:t})=>t&&e.headCells.draggingStyle};
`,ie=t.css`
	cursor: pointer;
	span.__rdt_custom_sort_icon__ {
		i,
		svg {
			transform: 'translate3d(0, 0, 0)';
			${({sortActive:e})=>e?"opacity: 1":"opacity: 0"};
			color: inherit;
			font-size: 18px;
			height: 18px;
			width: 18px;
			backface-visibility: hidden;
			transform-style: preserve-3d;
			transition-duration: 95ms;
			transition-property: transform;
		}

		&.asc i,
		&.asc svg {
			transform: rotate(180deg);
		}
	}

	${({sortActive:e})=>!e&&t.css`
			&:hover,
			&:focus {
				opacity: 0.7;

				span,
				span.__rdt_custom_sort_icon__ * {
					opacity: 0.7;
				}
			}
		`};
`,se=i.default.div`
	display: inline-flex;
	align-items: center;
	justify-content: inherit;
	height: 100%;
	width: 100%;
	outline: none;
	user-select: none;
	overflow: hidden;
	${({disabled:e})=>!e&&ie};
`,de=i.default.div`
	overflow: hidden;
	white-space: nowrap;
	text-overflow: ellipsis;
`,ce=i.default.div`
	display: block;
	position: absolute;
	cursor: col-resize;
	width: 7px;
	min-height: 52px;
	right 0;
	top: 0;
	z-index: 2;
	border-right: 2px solid transparent;
	&:hover {
		border-color: #ccc;
	}
	&.active {
		border-color: #add8e6;
	}
`;var ge=l.memo((function({column:e,disabled:t,draggingColumnId:n,resizingColumnId:o,selectedColumn:r={},sortDirection:i,sortIcon:s,sortServer:d,pagination:c,paginationServer:g,persistSelectedOnSort:u,selectableRowsVisibleOnly:p,onSort:f,onDragStart:m,onDragOver:b,onDragEnd:h,onDragEnter:w,onDragLeave:C,handleResizeStart:v,setColumnOffset:y}){const[R,S]=l.useState(!1),E=l.useRef(null),[O,k]=l.useState(0);if(l.useEffect((()=>{E.current&&S(E.current.scrollWidth>E.current.clientWidth)}),[R]),l.useEffect((()=>{var t;if(E.current&&e.freeze&&e.id){const n=(null===(t=E.current.parentNode)||void 0===t?void 0:t.parentNode).offsetLeft;y(n,e.id),k(n)}}),[O]),l.useEffect((()=>{var t;if(E.current&&e.freeze&&e.id&&(x(e.id,n)||x(e.id,o))){const n=(null===(t=E.current.parentNode)||void 0===t?void 0:t.parentNode).offsetLeft;y(n,e.id)}}),[n,o]),e.omit)return null;const P=()=>{if(!e.sortable&&!e.selector)return;let t=i;x(r.id,e.id)&&(t=i===a.ASC?a.DESC:a.ASC),f({type:"SORT_CHANGE",sortDirection:t,selectedColumn:e,clearSelectedOnSort:c&&g&&!u||d||p})},D=e=>l.createElement(le,{sortActive:e,sortDirection:i}),$=()=>l.createElement("span",{className:[i,"__rdt_custom_sort_icon__"].join(" ")},s),H=!(!e.sortable||!x(r.id,e.id)),j=!e.sortable||t,F=e.sortable&&!s&&!e.right,I=e.sortable&&!s&&e.right,T=e.sortable&&s&&!e.right,L=e.sortable&&s&&e.right;return l.createElement(re,{"data-column-id":e.id,className:"rdt_TableCol",headCell:!0,allowOverflow:e.allowOverflow,button:e.button,compact:e.compact,grow:e.grow,hide:e.hide,freeze:e.freeze,leftOffset:e.leftOffset,maxWidth:e.maxWidth,minWidth:e.minWidth,right:e.right,center:e.center,width:e.width,draggable:e.reorder&&""===o,isDragging:x(e.id,n),onDragStart:m,onDragOver:b,onDragEnd:h,onDragEnter:w,onDragLeave:C},e.name&&l.createElement(se,{"data-column-id":e.id,"data-sort-id":e.id,role:"columnheader",tabIndex:0,className:"rdt_TableCol_Sortable",onClick:j?void 0:P,onKeyPress:j?void 0:e=>{"Enter"===e.key&&P()},sortActive:!j&&H,disabled:j},!j&&L&&$(),!j&&I&&D(H),"string"==typeof e.name?l.createElement(de,{title:R?e.name:void 0,ref:E,"data-column-id":e.id},e.name):l.createElement(de,{ref:E,"data-column-id":e.id},e.name),!j&&T&&$(),!j&&F&&D(H)),e.resize&&l.createElement(ce,{className:"rdt_ResizeHandle "+(x(e.id,o)?"active":""),onPointerDown:v}))}));const ue=i.default(I)`
	flex: 0 0 48px;
	justify-content: center;
	align-items: center;
	user-select: none;
	white-space: nowrap;
	font-size: unset;
`;function pe({headCell:e=!0,rowData:t,keyField:n,allSelected:o,mergeSelections:a,selectedRows:r,selectableRowsComponent:i,selectableRowsComponentProps:s,selectableRowDisabled:d,onSelectAllRows:c}){const g=r.length>0&&!o,u=d?t.filter((e=>!d(e))):t,p=0===u.length,f=Math.min(t.length,u.length);return l.createElement(ue,{className:"rdt_TableCol",headCell:e,noPadding:!0},l.createElement(N,{name:"select-all-rows",component:i,componentOptions:s,onClick:()=>{c({type:"SELECT_ALL_ROWS",rows:u,rowCount:f,mergeSelections:a,keyField:n})},checked:o,indeterminate:g,disabled:p}))}function fe(e=exports.Direction.AUTO){const t="object"==typeof window,[n,o]=l.useState(!1);return l.useEffect((()=>{if(t)if("auto"!==e)o("rtl"===e);else{const e=!(!window.document||!window.document.createElement),t=document.getElementsByTagName("BODY")[0],n=document.getElementsByTagName("HTML")[0],a="rtl"===t.dir||"rtl"===n.dir;o(e&&a)}}),[e,t]),n}const me=i.default.div`
	display: flex;
	align-items: center;
	flex: 1 0 auto;
	height: 100%;
	color: ${({theme:e})=>e.contextMenu.fontColor};
	font-size: ${({theme:e})=>e.contextMenu.fontSize};
	font-weight: 400;
`,be=i.default.div`
	display: flex;
	align-items: center;
	justify-content: flex-end;
	flex-wrap: wrap;
`,he=i.default.div`
	position: absolute;
	top: 0;
	left: 0;
	width: 100%;
	height: 100%;
	box-sizing: inherit;
	z-index: 2;
	align-items: center;
	justify-content: space-between;
	display: flex;
	${({rtl:e})=>e&&"direction: rtl"};
	${({theme:e})=>e.contextMenu.style};
	${({theme:e,visible:t})=>t&&e.contextMenu.activeStyle};
`;function we({contextMessage:e,contextActions:t,contextComponent:n,selectedCount:o,direction:a}){const r=fe(a),i=o>0;return n?l.createElement(he,{visible:i},l.cloneElement(n,{selectedCount:o})):l.createElement(he,{visible:i,rtl:r},l.createElement(me,null,((e,t,n)=>{if(0===t)return null;const o=1===t?e.singular:e.plural;return n?`${t} ${e.message||""} ${o}`:`${t} ${o} ${e.message||""}`})(e,o,r)),l.createElement(be,null,t))}const xe=i.default.div`
	position: relative;
	box-sizing: border-box;
	overflow: hidden;
	display: flex;
	flex: 1 1 auto;
	align-items: center;
	justify-content: space-between;
	width: 100%;
	flex-wrap: wrap;
	${({theme:e})=>e.header.style}
`,Ce=i.default.div`
	flex: 1 0 auto;
	color: ${({theme:e})=>e.header.fontColor};
	font-size: ${({theme:e})=>e.header.fontSize};
	font-weight: 400;
`,ve=i.default.div`
	flex: 1 0 auto;
	display: flex;
	align-items: center;
	justify-content: flex-end;

	> * {
		margin-left: 5px;
	}
`,ye=({title:e,actions:t=null,contextMessage:n,contextActions:o,contextComponent:a,selectedCount:r,direction:i,showMenu:s=!0})=>l.createElement(xe,{className:"rdt_TableHeader",role:"heading","aria-level":1},l.createElement(Ce,null,e),t&&l.createElement(ve,null,t),s&&l.createElement(we,{contextMessage:n,contextActions:o,contextComponent:a,direction:i,selectedCount:r}));function Re(e,t){var n={};for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.indexOf(o)<0&&(n[o]=e[o]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var a=0;for(o=Object.getOwnPropertySymbols(e);a<o.length;a++)t.indexOf(o[a])<0&&Object.prototype.propertyIsEnumerable.call(e,o[a])&&(n[o[a]]=e[o[a]])}return n}"function"==typeof SuppressedError&&SuppressedError;const Se={left:"flex-start",right:"flex-end",center:"center"},Ee=i.default.header`
	position: relative;
	display: flex;
	flex: 1 1 auto;
	box-sizing: border-box;
	align-items: center;
	padding: 4px 16px 4px 24px;
	width: 100%;
	justify-content: ${({align:e})=>Se[e]};
	flex-wrap: ${({wrapContent:e})=>e?"wrap":"nowrap"};
	${({theme:e})=>e.subHeader.style}
`,Oe=e=>{var{align:t="right",wrapContent:n=!0}=e,o=Re(e,["align","wrapContent"]);return l.createElement(Ee,Object.assign({align:t,wrapContent:n},o))},ke=i.default.div`
	display: flex;
	flex-direction: column;
`,Pe=i.default.div`
	position: relative;
	width: 100%;
	border-radius: inherit;
	${({responsive:e,fixedHeader:n})=>e&&t.css`
			overflow-x: auto;

			// hidden prevents vertical scrolling in firefox when fixedHeader is disabled
			overflow-y: ${n?"auto":"hidden"};
			min-height: 0;
		`};

	${({fixedHeader:e=!1,fixedHeaderScrollHeight:n="100vh"})=>e&&t.css`
			max-height: ${n};
			-webkit-overflow-scrolling: touch;
		`};

	${({theme:e})=>e.responsiveWrapper.style};
`,De=i.default.div`
	position: relative;
	box-sizing: border-box;
	width: 100%;
	height: 100%;
	${e=>e.theme.progress.style};
`,$e=i.default.div`
	position: relative;
	width: 100%;
	${({theme:e})=>e.tableWrapper.style};
`,He=i.default(I)`
	white-space: nowrap;
	${({theme:e})=>e.expanderCell.style};
`,je=i.default.div`
	box-sizing: border-box;
	width: 100%;
	height: 100%;
	${({theme:e})=>e.noData.style};
`,Fe=()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24"},r.default.createElement("path",{d:"M7 10l5 5 5-5z"}),r.default.createElement("path",{d:"M0 0h24v24H0z",fill:"none"})),Ie=i.default.select`
	cursor: pointer;
	height: 24px;
	max-width: 100%;
	user-select: none;
	padding-left: 8px;
	padding-right: 24px;
	box-sizing: content-box;
	font-size: inherit;
	color: inherit;
	border: none;
	background-color: transparent;
	appearance: none;
	direction: ltr;
	flex-shrink: 0;

	&::-ms-expand {
		display: none;
	}

	&:disabled::-ms-expand {
		background: #f60;
	}

	option {
		color: initial;
	}
`,Te=i.default.div`
	position: relative;
	flex-shrink: 0;
	font-size: inherit;
	color: inherit;
	margin-top: 1px;

	svg {
		top: 0;
		right: 0;
		color: inherit;
		position: absolute;
		fill: currentColor;
		width: 24px;
		height: 24px;
		display: inline-block;
		user-select: none;
		pointer-events: none;
	}
`,Le=e=>{var{defaultValue:t,onChange:n}=e,o=Re(e,["defaultValue","onChange"]);return l.createElement(Te,null,l.createElement(Ie,Object.assign({onChange:n,defaultValue:t},o)),l.createElement(Fe,null))},Me={columns:[],data:[],title:"",keyField:"id",selectableRows:!1,selectableRowsHighlight:!1,selectableRowsNoSelectAll:!1,selectableRowSelected:null,selectableRowDisabled:null,selectableRowsComponent:"input",selectableRowsComponentProps:{},selectableRowsVisibleOnly:!1,selectableRowsSingle:!1,clearSelectedRows:!1,expandableRows:!1,expandableRowDisabled:null,expandableRowExpanded:null,expandOnRowClicked:!1,expandableRowsHideExpander:!1,expandOnRowDoubleClicked:!1,expandableInheritConditionalStyles:!1,expandableRowsComponent:function(){return r.default.createElement("div",null,"To add an expander pass in a component instance via ",r.default.createElement("strong",null,"expandableRowsComponent"),". You can then access props.data from this component.")},expandableIcon:{collapsed:r.default.createElement((()=>r.default.createElement("svg",{fill:"currentColor",height:"24",viewBox:"0 0 24 24",width:"24",xmlns:"http://www.w3.org/2000/svg"},r.default.createElement("path",{d:"M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z"}),r.default.createElement("path",{d:"M0-.25h24v24H0z",fill:"none"}))),null),expanded:r.default.createElement((()=>r.default.createElement("svg",{fill:"currentColor",height:"24",viewBox:"0 0 24 24",width:"24",xmlns:"http://www.w3.org/2000/svg"},r.default.createElement("path",{d:"M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"}),r.default.createElement("path",{d:"M0-.75h24v24H0z",fill:"none"}))),null)},expandableRowsComponentProps:{},progressPending:!1,progressComponent:r.default.createElement("div",{style:{fontSize:"24px",fontWeight:700,padding:"24px"}},"Loading..."),persistTableHead:!1,sortIcon:null,sortFunction:null,sortServer:!1,striped:!1,highlightOnHover:!1,pointerOnHover:!1,noContextMenu:!1,contextMessage:{singular:"item",plural:"items",message:"selected"},actions:null,contextActions:null,contextComponent:null,defaultSortFieldId:null,defaultSortAsc:!0,responsive:!0,noDataComponent:r.default.createElement("div",{style:{padding:"24px"}},"There are no records to display"),disabled:!1,noTableHead:!1,noHeader:!1,subHeader:!1,subHeaderAlign:exports.Alignment.RIGHT,subHeaderWrap:!0,subHeaderComponent:null,fixedHeader:!1,fixedHeaderScrollHeight:"100vh",pagination:!1,paginationServer:!1,paginationServerOptions:{persistSelectedOnSort:!1,persistSelectedOnPageChange:!1},paginationDefaultPage:1,paginationResetDefaultPage:!1,paginationTotalRows:0,paginationPerPage:10,paginationRowsPerPageOptions:[10,15,20,25,30],paginationComponent:null,paginationComponentOptions:{},paginationIconFirstPage:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z"}),r.default.createElement("path",{fill:"none",d:"M24 24H0V0h24v24z"}))),null),paginationIconLastPage:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z"}),r.default.createElement("path",{fill:"none",d:"M0 0h24v24H0V0z"}))),null),paginationIconNext:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"}),r.default.createElement("path",{d:"M0 0h24v24H0z",fill:"none"}))),null),paginationIconPrevious:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"}),r.default.createElement("path",{d:"M0 0h24v24H0z",fill:"none"}))),null),dense:!1,conditionalRowStyles:[],theme:"default",customStyles:{},direction:exports.Direction.AUTO,onChangePage:m,onChangeRowsPerPage:m,onRowClicked:m,onRowDoubleClicked:m,onRowMouseEnter:m,onRowMouseLeave:m,onRowExpandToggled:m,onSelectedRowsChange:m,onSort:m,onColumnOrderChange:m},ze={rowsPerPageText:"Rows per page:",rangeSeparatorText:"of",noRowsPerPage:!1,selectAllRowsItem:!1,selectAllRowsItemText:"All"},Ae=i.default.nav`
	display: flex;
	flex: 1 1 auto;
	justify-content: flex-end;
	align-items: center;
	box-sizing: border-box;
	padding-right: 8px;
	padding-left: 8px;
	width: 100%;
	${({theme:e})=>e.pagination.style};
`,_e=i.default.button`
	position: relative;
	display: block;
	user-select: none;
	border: none;
	${({theme:e})=>e.pagination.pageButtonsStyle};
	${({isRTL:e})=>e&&"transform: scale(-1, -1)"};
`,Ne=i.default.div`
	display: flex;
	align-items: center;
	border-radius: 4px;
	white-space: nowrap;
	${O`
    width: 100%;
    justify-content: space-around;
  `};
`,We=i.default.span`
	flex-shrink: 1;
	user-select: none;
`,Be=i.default(We)`
	margin: 0 24px;
`,Ge=i.default(We)`
	margin: 0 4px;
`;var Ve=l.memo((function({rowsPerPage:e,rowCount:t,currentPage:n,direction:o=Me.direction,paginationRowsPerPageOptions:a=Me.paginationRowsPerPageOptions,paginationIconLastPage:r=Me.paginationIconLastPage,paginationIconFirstPage:i=Me.paginationIconFirstPage,paginationIconNext:s=Me.paginationIconNext,paginationIconPrevious:d=Me.paginationIconPrevious,paginationComponentOptions:c=Me.paginationComponentOptions,onChangeRowsPerPage:g=Me.onChangeRowsPerPage,onChangePage:u=Me.onChangePage}){const f=(()=>{const e="object"==typeof window;function t(){return{width:e?window.innerWidth:void 0,height:e?window.innerHeight:void 0}}const[n,o]=l.useState(t);return l.useEffect((()=>{if(!e)return()=>null;function n(){o(t())}return window.addEventListener("resize",n),()=>window.removeEventListener("resize",n)}),[]),n})(),m=fe(o),b=f.width&&f.width>599,h=p(t,e),w=n*e,x=w-e+1,C=1===n,v=n===h,y=Object.assign(Object.assign({},ze),c),R=n===h?`${x}-${t} ${y.rangeSeparatorText} ${t}`:`${x}-${w} ${y.rangeSeparatorText} ${t}`,S=l.useCallback((()=>u(n-1)),[n,u]),E=l.useCallback((()=>u(n+1)),[n,u]),O=l.useCallback((()=>u(1)),[u]),k=l.useCallback((()=>u(p(t,e))),[u,t,e]),P=l.useCallback((e=>g(Number(e.target.value),n)),[n,g]),D=a.map((e=>l.createElement("option",{key:e,value:e},e)));y.selectAllRowsItem&&D.push(l.createElement("option",{key:-1,value:t},y.selectAllRowsItemText));const $=l.createElement(Le,{onChange:P,defaultValue:e,"aria-label":y.rowsPerPageText},D);return l.createElement(Ae,{className:"rdt_Pagination"},!y.noRowsPerPage&&b&&l.createElement(l.Fragment,null,l.createElement(Ge,null,y.rowsPerPageText),$),b&&l.createElement(Be,null,R),l.createElement(Ne,null,l.createElement(_e,{id:"pagination-first-page",type:"button","aria-label":"First Page","aria-disabled":C,onClick:O,disabled:C,isRTL:m},i),l.createElement(_e,{id:"pagination-previous-page",type:"button","aria-label":"Previous Page","aria-disabled":C,onClick:S,disabled:C,isRTL:m},d),!y.noRowsPerPage&&!b&&$,l.createElement(_e,{id:"pagination-next-page",type:"button","aria-label":"Next Page","aria-disabled":v,onClick:E,disabled:v,isRTL:m},s),l.createElement(_e,{id:"pagination-last-page",type:"button","aria-label":"Last Page","aria-disabled":v,onClick:k,disabled:v,isRTL:m},r)))}));const Ue=(e,t)=>{const n=l.useRef(!0);l.useEffect((()=>{n.current?n.current=!1:e()}),t)};var qe=function(e){return function(e){return!!e&&"object"==typeof e}(e)&&!function(e){var t=Object.prototype.toString.call(e);return"[object RegExp]"===t||"[object Date]"===t||function(e){return e.$$typeof===Ye}(e)}(e)};var Ye="function"==typeof Symbol&&Symbol.for?Symbol.for("react.element"):60103;function Ke(e,t){return!1!==t.clone&&t.isMergeableObject(e)?et((n=e,Array.isArray(n)?[]:{}),e,t):e;var n}function Xe(e,t,n){return e.concat(t).map((function(e){return Ke(e,n)}))}function Je(e){return Object.keys(e).concat(function(e){return Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(e).filter((function(t){return Object.propertyIsEnumerable.call(e,t)})):[]}(e))}function Qe(e,t){try{return t in e}catch(e){return!1}}function Ze(e,t,n){var o={};return n.isMergeableObject(e)&&Je(e).forEach((function(t){o[t]=Ke(e[t],n)})),Je(t).forEach((function(a){(function(e,t){return Qe(e,t)&&!(Object.hasOwnProperty.call(e,t)&&Object.propertyIsEnumerable.call(e,t))})(e,a)||(Qe(e,a)&&n.isMergeableObject(t[a])?o[a]=function(e,t){if(!t.customMerge)return et;var n=t.customMerge(e);return"function"==typeof n?n:et}(a,n)(e[a],t[a],n):o[a]=Ke(t[a],n))})),o}function et(e,t,n){(n=n||{}).arrayMerge=n.arrayMerge||Xe,n.isMergeableObject=n.isMergeableObject||qe,n.cloneUnlessOtherwiseSpecified=Ke;var o=Array.isArray(t);return o===Array.isArray(e)?o?n.arrayMerge(e,t,n):Ze(e,t,n):Ke(t,n)}et.all=function(e,t){if(!Array.isArray(e))throw new Error("first argument should be an array");return e.reduce((function(e,n){return et(e,n,t)}),{})};var tt=et;const nt={text:{primary:"rgba(0, 0, 0, 0.87)",secondary:"rgba(0, 0, 0, 0.54)",disabled:"rgba(0, 0, 0, 0.38)"},background:{default:"#FFFFFF"},context:{background:"#e3f2fd",text:"rgba(0, 0, 0, 0.87)"},divider:{default:"rgba(0,0,0,.12)"},button:{default:"rgba(0,0,0,.54)",focus:"rgba(0,0,0,.12)",hover:"rgba(0,0,0,.12)",disabled:"rgba(0, 0, 0, .18)"},selected:{default:"#e3f2fd",text:"rgba(0, 0, 0, 0.87)"},highlightOnHover:{default:"#EEEEEE",text:"rgba(0, 0, 0, 0.87)"},striped:{default:"#FAFAFA",text:"rgba(0, 0, 0, 0.87)"}},ot={default:nt,light:nt,dark:{text:{primary:"#FFFFFF",secondary:"rgba(255, 255, 255, 0.7)",disabled:"rgba(0,0,0,.12)"},background:{default:"#424242"},context:{background:"#E91E63",text:"#FFFFFF"},divider:{default:"rgba(81, 81, 81, 1)"},button:{default:"#FFFFFF",focus:"rgba(255, 255, 255, .54)",hover:"rgba(255, 255, 255, .12)",disabled:"rgba(255, 255, 255, .18)"},selected:{default:"rgba(0, 0, 0, .7)",text:"#FFFFFF"},highlightOnHover:{default:"rgba(0, 0, 0, .7)",text:"#FFFFFF"},striped:{default:"rgba(0, 0, 0, .87)",text:"#FFFFFF"}}};function at(e,t,n,o){const[r,i]=l.useState((()=>u(e))),[s,d]=l.useState(""),[c,g]=l.useState(""),[p,f]=l.useState(null),m=l.useRef("");Ue((()=>{i(u(e))}),[e]);const b=l.useCallback((e=>{var t,n,o;const{attributes:a}=e.target,l=null===(t=a.getNamedItem("data-column-id"))||void 0===t?void 0:t.value;l&&(m.current=(null===(o=null===(n=r[w(r,l)])||void 0===n?void 0:n.id)||void 0===o?void 0:o.toString())||"",d(m.current))}),[r]),h=l.useCallback((e=>{var n;const{attributes:o}=e.target,a=null===(n=o.getNamedItem("data-column-id"))||void 0===n?void 0:n.value;if(a&&m.current&&a!==m.current){const e=w(r,m.current),n=w(r,a),o=[...r];o[e]=r[n],o[n]=r[e],i(o),t(o)}}),[t,r]),x=l.useCallback((e=>{e.preventDefault()}),[]),C=l.useCallback((e=>{e.preventDefault()}),[]),v=l.useCallback((e=>{e.preventDefault(),m.current="",d("")}),[]),y=l.useCallback((e=>{var t,n,o;const a=e.target,{attributes:l}=null==a?void 0:a.parentNode,i=null===(t=l.getNamedItem("data-column-id"))||void 0===t?void 0:t.value;i&&(m.current=(null===(o=null===(n=r[w(r,i)])||void 0===n?void 0:n.id)||void 0===o?void 0:o.toString())||"",g(m.current),f(e.target))}),[r]),R=l.useCallback((e=>{var t,n;if(""===c||null===p)return;const o=w(r,c),a=null==p?void 0:p.parentNode,l=[...r];let s=e.clientX-Math.trunc(a.getBoundingClientRect().left);const d=Number(null===(t=l[o].minWidth)||void 0===t?void 0:t.replace(/\D/g,"")),g=Number(null===(n=l[o].maxWidth)||void 0===n?void 0:n.replace(/\D/g,""));s=d&&s<d?d:g&&s>g?g:Math.max(s,10),l[o].width=`${s}px`,i(l)}),[c,r]),S=l.useCallback((()=>{g("")}),[]),E=function(e=!1){return e?a.ASC:a.DESC}(o),O=l.useMemo((()=>r[w(r,null==n?void 0:n.toString())]||{}),[n,r]);l.useEffect((()=>(""!==c&&(window.addEventListener("pointermove",R),window.addEventListener("pointerup",S)),()=>{window.removeEventListener("pointermove",R),window.removeEventListener("pointerup",S)})),[c]);return{tableColumns:r,draggingColumnId:s,handleDragStart:b,handleDragEnter:h,handleDragOver:x,handleDragLeave:C,handleDragEnd:v,defaultSortDirection:E,defaultSortColumn:O,resizingColumnId:c,handleResizeStart:y,setColumnOffset:(e,t)=>{const n=w(r,t.toString()),o=[...r];o[n].leftOffset=`${e}px`,i(o)}}}var lt=l.memo((function(e){const{data:n=Me.data,columns:o=Me.columns,title:r=Me.title,actions:i=Me.actions,keyField:c=Me.keyField,striped:g=Me.striped,highlightOnHover:u=Me.highlightOnHover,pointerOnHover:m=Me.pointerOnHover,dense:b=Me.dense,selectableRows:w=Me.selectableRows,selectableRowsSingle:x=Me.selectableRowsSingle,selectableRowsHighlight:v=Me.selectableRowsHighlight,selectableRowsNoSelectAll:R=Me.selectableRowsNoSelectAll,selectableRowsVisibleOnly:O=Me.selectableRowsVisibleOnly,selectableRowSelected:k=Me.selectableRowSelected,selectableRowDisabled:P=Me.selectableRowDisabled,selectableRowsComponent:D=Me.selectableRowsComponent,selectableRowsComponentProps:$=Me.selectableRowsComponentProps,onRowExpandToggled:H=Me.onRowExpandToggled,onSelectedRowsChange:j=Me.onSelectedRowsChange,expandableIcon:F=Me.expandableIcon,onChangeRowsPerPage:T=Me.onChangeRowsPerPage,onChangePage:L=Me.onChangePage,paginationServer:M=Me.paginationServer,paginationServerOptions:z=Me.paginationServerOptions,paginationTotalRows:A=Me.paginationTotalRows,paginationDefaultPage:_=Me.paginationDefaultPage,paginationResetDefaultPage:N=Me.paginationResetDefaultPage,paginationPerPage:W=Me.paginationPerPage,paginationRowsPerPageOptions:B=Me.paginationRowsPerPageOptions,paginationIconLastPage:G=Me.paginationIconLastPage,paginationIconFirstPage:V=Me.paginationIconFirstPage,paginationIconNext:U=Me.paginationIconNext,paginationIconPrevious:q=Me.paginationIconPrevious,paginationComponent:Y=Me.paginationComponent,paginationComponentOptions:K=Me.paginationComponentOptions,responsive:X=Me.responsive,progressPending:J=Me.progressPending,progressComponent:Q=Me.progressComponent,persistTableHead:Z=Me.persistTableHead,noDataComponent:ee=Me.noDataComponent,disabled:te=Me.disabled,noTableHead:ne=Me.noTableHead,noHeader:ae=Me.noHeader,fixedHeader:le=Me.fixedHeader,fixedHeaderScrollHeight:re=Me.fixedHeaderScrollHeight,pagination:ie=Me.pagination,subHeader:se=Me.subHeader,subHeaderAlign:de=Me.subHeaderAlign,subHeaderWrap:ce=Me.subHeaderWrap,subHeaderComponent:ue=Me.subHeaderComponent,noContextMenu:fe=Me.noContextMenu,contextMessage:me=Me.contextMessage,contextActions:be=Me.contextActions,contextComponent:he=Me.contextComponent,expandableRows:we=Me.expandableRows,onRowClicked:xe=Me.onRowClicked,onRowDoubleClicked:Ce=Me.onRowDoubleClicked,onRowMouseEnter:ve=Me.onRowMouseEnter,onRowMouseLeave:Re=Me.onRowMouseLeave,sortIcon:Se=Me.sortIcon,onSort:Ee=Me.onSort,sortFunction:Fe=Me.sortFunction,sortServer:Ie=Me.sortServer,expandableRowsComponent:Te=Me.expandableRowsComponent,expandableRowsComponentProps:Le=Me.expandableRowsComponentProps,expandableRowDisabled:ze=Me.expandableRowDisabled,expandableRowsHideExpander:Ae=Me.expandableRowsHideExpander,expandOnRowClicked:_e=Me.expandOnRowClicked,expandOnRowDoubleClicked:Ne=Me.expandOnRowDoubleClicked,expandableRowExpanded:We=Me.expandableRowExpanded,expandableInheritConditionalStyles:Be=Me.expandableInheritConditionalStyles,defaultSortFieldId:Ge=Me.defaultSortFieldId,defaultSortAsc:qe=Me.defaultSortAsc,clearSelectedRows:Ye=Me.clearSelectedRows,conditionalRowStyles:Ke=Me.conditionalRowStyles,theme:Xe=Me.theme,customStyles:Je=Me.customStyles,direction:Qe=Me.direction,onColumnOrderChange:Ze=Me.onColumnOrderChange,className:et}=e,{tableColumns:nt,draggingColumnId:lt,handleDragStart:rt,handleDragEnter:it,handleDragOver:st,handleDragLeave:dt,handleDragEnd:ct,defaultSortDirection:gt,defaultSortColumn:ut,resizingColumnId:pt,handleResizeStart:ft,setColumnOffset:mt}=at(o,Ze,Ge,qe),[{rowsPerPage:bt,currentPage:ht,selectedRows:wt,allSelected:xt,selectedCount:Ct,selectedColumn:vt,sortDirection:yt,toggleOnSelectedRowsChange:Rt},St]=l.useReducer(C,{allSelected:!1,selectedCount:0,selectedRows:[],selectedColumn:ut,toggleOnSelectedRowsChange:!1,sortDirection:gt,currentPage:_,rowsPerPage:W,selectedRowsFlag:!1,contextMessage:Me.contextMessage}),{persistSelectedOnSort:Et=!1,persistSelectedOnPageChange:Ot=!1}=z,kt=!(!M||!Ot&&!Et),Pt=ie&&!J&&n.length>0,Dt=Y||Ve,$t=l.useMemo((()=>((e={},t="default",n="default")=>{const o=ot[t]?t:n;return tt({table:{style:{color:(a=ot[o]).text.primary,backgroundColor:a.background.default}},tableWrapper:{style:{display:"table"}},responsiveWrapper:{style:{}},header:{style:{fontSize:"22px",color:a.text.primary,backgroundColor:a.background.default,minHeight:"56px",paddingLeft:"16px",paddingRight:"8px"}},subHeader:{style:{backgroundColor:a.background.default,minHeight:"52px"}},head:{style:{color:a.text.primary,fontSize:"12px",fontWeight:500}},headRow:{style:{backgroundColor:a.background.default,minHeight:"52px",borderBottomWidth:"1px",borderBottomColor:a.divider.default,borderBottomStyle:"solid"},denseStyle:{minHeight:"32px"}},headCells:{style:{paddingLeft:"16px",paddingRight:"16px"},draggingStyle:{cursor:"move"}},contextMenu:{style:{backgroundColor:a.context.background,fontSize:"18px",fontWeight:400,color:a.context.text,paddingLeft:"16px",paddingRight:"8px",transform:"translate3d(0, -100%, 0)",transitionDuration:"125ms",transitionTimingFunction:"cubic-bezier(0, 0, 0.2, 1)",willChange:"transform"},activeStyle:{transform:"translate3d(0, 0, 0)"}},cells:{style:{paddingLeft:"16px",paddingRight:"16px",wordBreak:"break-word"},draggingStyle:{}},rows:{style:{fontSize:"13px",fontWeight:400,color:a.text.primary,backgroundColor:a.background.default,minHeight:"48px","&:not(:last-of-type)":{borderBottomStyle:"solid",borderBottomWidth:"1px",borderBottomColor:a.divider.default}},denseStyle:{minHeight:"32px"},selectedHighlightStyle:{"&:nth-of-type(n)":{color:a.selected.text,backgroundColor:a.selected.default,borderBottomColor:a.background.default}},highlightOnHoverStyle:{color:a.highlightOnHover.text,backgroundColor:a.highlightOnHover.default,transitionDuration:"0.15s",transitionProperty:"background-color",borderBottomColor:a.background.default,outlineStyle:"solid",outlineWidth:"1px",outlineColor:a.background.default},stripedStyle:{color:a.striped.text,backgroundColor:a.striped.default}},expanderRow:{style:{color:a.text.primary,backgroundColor:a.background.default}},expanderCell:{style:{flex:"0 0 48px"}},expanderButton:{style:{color:a.button.default,fill:a.button.default,backgroundColor:"transparent",borderRadius:"2px",transition:"0.25s",height:"100%",width:"100%","&:hover:enabled":{cursor:"pointer"},"&:disabled":{color:a.button.disabled},"&:hover:not(:disabled)":{cursor:"pointer",backgroundColor:a.button.hover},"&:focus":{outline:"none",backgroundColor:a.button.focus},svg:{margin:"auto"}}},pagination:{style:{color:a.text.secondary,fontSize:"13px",minHeight:"56px",backgroundColor:a.background.default,borderTopStyle:"solid",borderTopWidth:"1px",borderTopColor:a.divider.default},pageButtonsStyle:{borderRadius:"50%",height:"40px",width:"40px",padding:"8px",margin:"px",cursor:"pointer",transition:"0.4s",color:a.button.default,fill:a.button.default,backgroundColor:"transparent","&:disabled":{cursor:"unset",color:a.button.disabled,fill:a.button.disabled},"&:hover:not(:disabled)":{backgroundColor:a.button.hover},"&:focus":{outline:"none",backgroundColor:a.button.focus}}},noData:{style:{display:"flex",alignItems:"center",justifyContent:"center",color:a.text.primary,backgroundColor:a.background.default}},progress:{style:{display:"flex",alignItems:"center",justifyContent:"center",color:a.text.primary,backgroundColor:a.background.default}}},e);var a})(Je,Xe)),[Je,Xe]),Ht=l.useMemo((()=>Object.assign({},"auto"!==Qe&&{dir:Qe})),[Qe]),jt=l.useMemo((()=>{if(Ie)return n;if((null==vt?void 0:vt.sortFunction)&&"function"==typeof vt.sortFunction){const e=vt.sortFunction,t=yt===a.ASC?e:(t,n)=>-1*e(t,n);return[...n].sort(t)}return function(e,t,n,o){return t?o&&"function"==typeof o?o(e.slice(0),t,n):e.slice(0).sort(((e,o)=>{let a,l;if("string"==typeof t?(a=d(e,t),l=d(o,t)):(a=t(e),l=t(o)),"asc"===n){if(a<l)return-1;if(a>l)return 1}if("desc"===n){if(a>l)return-1;if(a<l)return 1}return 0})):e}(n,null==vt?void 0:vt.selector,yt,Fe)}),[Ie,vt,yt,n,Fe]),Ft=l.useMemo((()=>{if(ie&&!M){const e=ht*bt,t=e-bt;return jt.slice(t,e)}return jt}),[ht,ie,M,bt,jt]),It=l.useCallback((e=>{St(e)}),[]),Tt=l.useCallback((e=>{St(e)}),[]),Lt=l.useCallback((e=>{St(e)}),[]),Mt=l.useCallback(((e,t)=>xe(e,t)),[xe]),zt=l.useCallback(((e,t)=>Ce(e,t)),[Ce]),At=l.useCallback(((e,t)=>ve(e,t)),[ve]),_t=l.useCallback(((e,t)=>Re(e,t)),[Re]),Nt=l.useCallback((e=>St({type:"CHANGE_PAGE",page:e,paginationServer:M,visibleOnly:O,persistSelectedOnPageChange:Ot})),[M,Ot,O]),Wt=l.useCallback((e=>{const t=p(A||Ft.length,e),n=f(ht,t);M||Nt(n),St({type:"CHANGE_ROWS_PER_PAGE",page:n,rowsPerPage:e})}),[ht,Nt,M,A,Ft.length]);if(ie&&!M&&jt.length>0&&0===Ft.length){const e=p(jt.length,bt),t=f(ht,e);Nt(t)}Ue((()=>{j({allSelected:xt,selectedCount:Ct,selectedRows:wt.slice(0)})}),[Rt]),Ue((()=>{Ee(vt,yt,jt.slice(0))}),[vt,yt]),Ue((()=>{L(ht,A||jt.length)}),[ht]),Ue((()=>{T(bt,ht)}),[bt]),Ue((()=>{Nt(_)}),[_,N]),Ue((()=>{if(ie&&M&&A>0){const e=p(A,bt),t=f(ht,e);ht!==t&&Nt(t)}}),[A]),l.useEffect((()=>{St({type:"CLEAR_SELECTED_ROWS",selectedRowsFlag:Ye})}),[x,Ye]),l.useEffect((()=>{if(!k)return;const e=jt.filter((e=>k(e))),t=x?e.slice(0,1):e;St({type:"SELECT_MULTIPLE_ROWS",keyField:c,selectedRows:t,totalRows:jt.length,mergeSelections:kt})}),[n,k]);const Bt=O?Ft:jt,Gt=Ot||x||R;return l.createElement(t.ThemeProvider,{theme:$t},!ae&&(!!r||!!i)&&l.createElement(ye,{title:r,actions:i,showMenu:!fe,selectedCount:Ct,direction:Qe,contextActions:be,contextComponent:he,contextMessage:me}),se&&l.createElement(Oe,{align:de,wrapContent:ce},ue),l.createElement(Pe,Object.assign({responsive:X,fixedHeader:le,fixedHeaderScrollHeight:re,className:et},Ht),l.createElement($e,null,J&&!Z&&l.createElement(De,null,Q),l.createElement(y,{disabled:te,className:"rdt_Table",role:"table"},!ne&&(!!Z||jt.length>0&&!J)&&l.createElement(S,{className:"rdt_TableHead",role:"rowgroup",fixedHeader:le},l.createElement(E,{className:"rdt_TableHeadRow",role:"row",dense:b},w&&(Gt?l.createElement(I,{style:{flex:"0 0 48px"}}):l.createElement(pe,{allSelected:xt,selectedRows:wt,selectableRowsComponent:D,selectableRowsComponentProps:$,selectableRowDisabled:P,rowData:Bt,keyField:c,mergeSelections:kt,onSelectAllRows:Tt})),we&&!Ae&&l.createElement(He,null),nt.map((e=>l.createElement(ge,{key:e.id,column:e,selectedColumn:vt,disabled:J||0===jt.length,pagination:ie,paginationServer:M,persistSelectedOnSort:Et,selectableRowsVisibleOnly:O,sortDirection:yt,sortIcon:Se,sortServer:Ie,onSort:It,onDragStart:rt,onDragOver:st,onDragEnd:ct,onDragEnter:it,onDragLeave:dt,draggingColumnId:lt,handleResizeStart:ft,resizingColumnId:pt,setColumnOffset:mt}))))),!jt.length&&!J&&l.createElement(je,null,ee),J&&Z&&l.createElement(De,null,Q),!J&&jt.length>0&&l.createElement(ke,{className:"rdt_TableBody",role:"rowgroup"},Ft.map(((e,t)=>{const n=s(e,c),o=function(e=""){return"number"!=typeof e&&(!e||0===e.length)}(n)?t:n,a=h(e,wt,c),r=!!(we&&We&&We(e)),i=!!(we&&ze&&ze(e));return l.createElement(oe,{id:o,key:o,keyField:c,"data-row-id":o,columns:nt,row:e,rowCount:jt.length,rowIndex:t,selectableRows:w,expandableRows:we,expandableIcon:F,highlightOnHover:u,pointerOnHover:m,dense:b,expandOnRowClicked:_e,expandOnRowDoubleClicked:Ne,expandableRowsComponent:Te,expandableRowsComponentProps:Le,expandableRowsHideExpander:Ae,defaultExpanderDisabled:i,defaultExpanded:r,expandableInheritConditionalStyles:Be,conditionalRowStyles:Ke,selected:a,selectableRowsHighlight:v,selectableRowsComponent:D,selectableRowsComponentProps:$,selectableRowDisabled:P,selectableRowsSingle:x,striped:g,onRowExpandToggled:H,onRowClicked:Mt,onRowDoubleClicked:zt,onRowMouseEnter:At,onRowMouseLeave:_t,onSelectedRow:Lt,draggingColumnId:lt,onDragStart:rt,onDragOver:st,onDragEnd:ct,onDragEnter:it,onDragLeave:dt})})))))),Pt&&l.createElement("div",null,l.createElement(Dt,{onChangePage:Nt,onChangeRowsPerPage:Wt,rowCount:A||jt.length,currentPage:ht,rowsPerPage:bt,direction:Qe,paginationRowsPerPageOptions:B,paginationIconLastPage:G,paginationIconFirstPage:V,paginationIconNext:U,paginationIconPrevious:q,paginationComponentOptions:K})))}));exports.STOP_PROP_TAG=X,exports.createTheme=function(e="default",t,n="default"){return ot[e]||(ot[e]=tt(ot[n],t||{})),ot[e]=tt(ot[e],t||{}),ot[e]},exports.default=lt,exports.defaultThemes=ot;
//# sourceMappingURL=index.cjs.js.map
